--- a/drivers/pcmcia/yenta_socket.c
+++ b/drivers/pcmcia/yenta_socket.c
@@ -923,6 +923,8 @@ static struct cardbus_type cardbus_type[
 
 static unsigned int yenta_probe_irq(struct yenta_socket *socket, u32 isa_irq_mask)
 {
+/* WRT54G3G does not like this */
+#ifndef CONFIG_BCM47XX
 	int i;
 	unsigned long val;
 	u32 mask;
@@ -951,6 +953,9 @@ static unsigned int yenta_probe_irq(stru
 	mask = probe_irq_mask(val) & 0xffff;
 
 	return mask;
+#else
+	return 0;
+#endif
 }
 
 
@@ -1031,6 +1036,10 @@ static void yenta_get_socket_capabilitie
 	else
 		socket->socket.irq_mask = 0;
 
+	/* irq mask probing is broken for the WRT54G3G */
+	if (socket->socket.irq_mask == 0)
+		socket->socket.irq_mask = 0x6f8;
+
 	dev_info(&socket->dev->dev, "ISA IRQ mask 0x%04x, PCI irq %d\n",
 		 socket->socket.irq_mask, socket->cb_irq);
 }
@@ -1262,6 +1271,15 @@ static int yenta_probe(struct pci_dev *d
 	dev_info(&dev->dev, "Socket status: %08x\n",
 		 cb_readl(socket, CB_SOCKET_STATE));
 
+	/* Generate an interrupt on card insert/remove */
+	config_writew(socket, CB_SOCKET_MASK, CB_CSTSMASK | CB_CDMASK);
+
+	/* Set up Multifunction Routing Status Register */
+	config_writew(socket, 0x8C, 0x1000 /* MFUNC3 to GPIO3 */ | 0x2 /* MFUNC0 to INTA */);
+
+	/* Switch interrupts to parallelized */
+	config_writeb(socket, 0x92, 0x64);
+
 	yenta_fixup_parent_bridge(dev->subordinate);
 
 	/* Register it with the pcmcia layer.. */
